/*
 * C'Gol
 * Project based on Conway's Game of Life
 * 
 * Made by:
 * Alexander Noss
 * Christian Rautenberg
 * David Zentner
 * Philipp Erler
 * Stephan Schneider
 * 
 * As IT project for summer-semester 2011 (Group IT2D)
 * 
 * ####################################################################
 * DLL base functions
 * Part of C'Gol C-DLL
 * ####################################################################
 * 
 * Last change:     2011 | 07 | 04
 * 
 * Mail me for feedback, version requests etc.: 	ph.erler@gmx.net
 * Look at http://www.hs-esslingen.de/~pherit00/website/index.htm
 * .Net - Framework 4.0 must be installed.
 * 
 */


#ifndef BASE_H_
	#define BASE_H_
		
	#include "globals.h"
	#include <stdio.h>
	#include <stdlib.h>
	#include <time.h>

	//Creates a two dimensional Array[x][y]--> our field, and initialisation with 0s
	extern __declspec(dllexport) void createArray(int size);

	//provides storage for the field
	extern __declspec(dllexport) void createArray(int newSize);
	
	//set size of field
	extern __declspec(dllexport) void setFieldSize(int size);
	
	//get cell state at pos
	extern __declspec(dllexport) int getCell(int x, int y);
	
	//release the storage of the field_pointer (ptrptrField)
	extern __declspec(dllexport) void deleteField();
	
	//init dll
	extern __declspec(dllexport) void initDll();

	//new field
	extern __declspec(dllexport) void newField(int newSize);

	//function for field Size
	extern __declspec(dllexport) int getFieldSize();

	//Creates a two dimensional Array[x][y]--> our field with zero values
	extern __declspec(dllexport) void createArrayRandom();

	//fill existing field
	extern __declspec(dllexport) void randomField();
	
	//change value from a position from 1to0 or 0to1
	extern __declspec(dllexport) void switchCell (int x, int y);
	
	//inizialisation from Rand, for a complete new random value
	void initRand();

#endif